/*  
    This file is part of Restraint.

    Restraint is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Restraint is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Restraint.  If not, see <http://www.gnu.org/licenses/>.
*/

#define DEFAULT_PORT 8081
#define DEFAULT_DELAY 60

struct _AppData;

typedef struct {
    xmlNodePtr recipe_node_ptr;
    GHashTable *tasks;
    guint recipe_id;
    SoupURI *remote_uri;
    SoupMessage *remote_msg;
    struct _AppData *app_data;
    GString *body;
} RecipeData;

typedef struct _AppData {
    GError *error;
    GMainLoop *loop;
    xmlDocPtr xml_doc;
    gchar *run_dir;
    GHashTable *result_states_to;
    GHashTable *recipes;
    gint verbose;
    guint port;
    SoupServer *server;
    SoupAddressFamily address_family;
    SoupURI *addr_get_uri;
    GCancellable *cancellable;
    gboolean started;
} AppData;
